diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/improvement.c freeciv-patched/common/improvement.c
--- freeciv-cvs/common/improvement.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/improvement.c	2003-06-30 12:18:17.000000000 +0100
@@ -19,6 +19,7 @@
 #include <string.h>
 
 #include "game.h"
+#include "government.h"
 #include "log.h"
 #include "map.h"
 #include "mem.h"
@@ -28,6 +29,18 @@
 
 #include "improvement.h"
 
+int B_CITY, B_PALACE;
+
+/* get 'struct ceff_vector' functions: */
+#define SPECVEC_TAG ceff
+#define SPECVEC_TYPE struct eff_city
+#include "specvec_c.h"
+
+/* get 'struct geff_vector' functions: */
+#define SPECVEC_TAG geff
+#define SPECVEC_TYPE struct eff_global
+#include "specvec_c.h"
+
 /* Names of impr ranges.
  * (These must correspond to enum impr_range_id in improvement.h.)
  * do not change these unless you know what you're doing! */
@@ -93,21 +106,21 @@
   "No_Sink_Deep",
   "Nuke_Proof",
   "Pollu_Adj",
-  "Pollu_Adj_Pop",
-  "Pollu_Adj_Prod",
-  "Pollu_Set",
-  "Pollu_Set_Pop",
-  "Pollu_Set_Prod",
+  "Pollu_Pop_Adj",
+  "Pollu_Prod_Adj",
+  "Pollu_Pct",
+  "Pollu_Pop_Pct",
+  "Pollu_Prod_Pct",
   "Prod_Add_Tile",
   "Prod_Bonus",
   "Prod_Inc_Tile",
   "Prod_Per_Tile",
   "Prod_To_Gold",
-  "Reduce_Corrupt",
-  "Reduce_Waste",
+  "Corrupt_Adj",
+  "Corrupt_Pct",
   "Reveal_Cities",
   "Reveal_Map",
-  "Revolt_Dist",
+  "Revolt_Dist_Adj",
   "Science_Bonus",
   "Science_Pct",
   "Size_Unlimit",
@@ -134,7 +147,22 @@
   "Upgrade_One_Leap",
   "Upgrade_All_Step",
   "Upgrade_All_Leap",
-  "Upkeep_Free"
+  "Upkeep_Free",
+  "Food_Pct",
+  "Prod_Pct",
+  "Revolt_Dist_Pct",
+  "Trade_Pct",
+  "Make_Content_Mil_Per",
+  "Force_Content",
+  "Force_Content_Pct",
+  "Force_Happy",
+  "Unit_Attack",
+  "Unit_Attack_Firepower",
+  "Unit_Defend_Firepower",
+  "Unit_Cost",
+  "Building_Cost",
+  "Unit_Cost_Pct",
+  "Building_Cost_Pct"
 };
 
 /**************************************************************************
@@ -318,6 +346,15 @@
 }
 
 /**************************************************************************
+  Returns the effective value of the improvement, after applying any
+  cost modifiers.
+**************************************************************************/
+int improvement_value_adjusted(Impr_Type_id id, struct city *pcity)
+{
+  return improvement_value(id) * pcity->impr_cost_pct / 100;
+}
+
+/**************************************************************************
 ...
 **************************************************************************/
 bool is_wonder(Impr_Type_id id)
@@ -493,9 +530,6 @@
     /* This if for a spaceship component is asked */
     while ((type = peffect->type) != EFT_LAST) {
       if (type == EFT_SPACE_PART) {
-      	/* TODO: remove this */
-	if (game.global_wonders[B_APOLLO] == 0)
-	  return FALSE;
         if (p->spaceship.state >= SSHIP_LAUNCHED)
 	  return FALSE;
 	if (peffect->amount == 1 && p->spaceship.structurals >= NUM_SS_STRUCTURALS)
@@ -567,14 +601,56 @@
 }
 
 /**************************************************************************
+  Rearranges the island-range effects to take account of continent number
+  changes.
+**************************************************************************/
+static void allot_island_effects(struct player *pplayer)
+{
+  int cont;
+  struct geff_vector *new_island_effects;
+
+  new_island_effects = fc_calloc(map.num_continents + 1,
+      				 sizeof(struct geff_vector));
+  for (cont = 1; cont <= map.num_continents; cont++) {
+    geff_vector_init(&new_island_effects[cont]);
+  }
+
+  for (cont = 1; cont <= map.old_num_continents; cont++) {
+    int i;
+    struct geff_vector *geff = get_eff_island(cont, pplayer);
+    for (i = 0; i < geff_vector_size(geff); i++) {
+      struct eff_global *eff = geff_vector_get(geff, i);
+      if (eff->eff.impr != B_LAST && eff->cityid >= 0) {
+        int newcont;
+        struct eff_global *neweff;
+        struct city *pcity = player_find_city_by_id(pplayer, eff->cityid);
+        assert(pcity);
+        newcont = map_get_continent(pcity->x, pcity->y);
+        neweff = append_geff(&new_island_effects[newcont]);
+        neweff->eff.impr = eff->eff.impr;
+        neweff->eff.active = eff->eff.active;
+        neweff->cityid = eff->cityid;
+      }
+    }
+    geff_vector_free(geff);
+  }
+  if (map.old_num_continents > 0) {
+    free(pplayer->island_effects);
+  }
+  pplayer->island_effects = new_island_effects;
+}
+
+/**************************************************************************
   Redimensions the lists of island-range improvements when number of
   continents changes. 
 **************************************************************************/
 void allot_island_improvs(void)
 {
   int i;
+  bool changed = FALSE;
 
   players_iterate(pplayer) {
+    allot_island_effects(pplayer);
     pplayer->island_improv = fc_realloc(pplayer->island_improv,
                                         (map.num_continents + 1)
                                         * game.num_impr_types
@@ -597,29 +673,26 @@
           continue;
         }
     
+        changed = TRUE;
         improvs[id] = pcity->improvements[id];
       } built_impr_iterate_end;
     } city_list_iterate_end;
   } players_iterate_end;
 
-  improvements_update_redundant(NULL, NULL, 0, IR_WORLD);  
+  map.old_num_continents = map.num_continents;
+  if (changed) {
+    update_all_effects();
+  }
 }   
 
 /**************************************************************************
-  Update the obsolete status of all improvements. This needs to be done 
-  when a tech is discovered.
+  Update the obsolete status of all improvements.
 
   For all players since wonders are obsoleted when anybody discovers the
   obsolescence tech.
-
-  If we marked something as obsolete, we need to call 
-  improvements_update_redundant(), since it might have made something 
-  unredundant.
 **************************************************************************/
 void improvements_update_obsolete(void)
 {   
-  bool did_mark = FALSE;
-
   players_iterate(pplayer) {
     city_list_iterate(pplayer->cities, pcity) {
       built_impr_iterate(pcity, i) {
@@ -627,17 +700,10 @@
           freelog(LOG_DEBUG,"%s in %s is obsolete",
                   improvement_types[i].name, pcity->name);
           mark_improvement(pcity, i, I_OBSOLETE);
-          did_mark = TRUE;
         }
       } built_impr_iterate_end;
     } city_list_iterate_end;
   } players_iterate_end;
-
-  /* Ideally, we could track at what max range and for which players, but
-   * that's overoptimizing by a bit */
-  if (did_mark) {
-    improvements_update_redundant(NULL, NULL, 0, IR_WORLD);
-  }
 }
 
 /**************************************************************************
@@ -713,3 +779,681 @@
 
 #undef CHECK_CITY_IMPR 
 }
+
+/**************************************************************************
+...
+**************************************************************************/
+struct geff_vector *get_eff_world(void)
+{
+  return (&game.effects);
+}
+  
+/**************************************************************************
+...
+**************************************************************************/
+struct geff_vector *get_eff_player(struct player *plr)
+{
+  return (&plr->effects);
+}
+  
+/**************************************************************************
+...
+**************************************************************************/
+struct geff_vector *get_eff_island(int cont, struct player *plr)
+{
+  return (&plr->island_effects[cont]);
+}
+  
+/**************************************************************************
+...
+**************************************************************************/
+struct ceff_vector *get_eff_city(struct city *pcity)
+{
+  return (&pcity->effects);
+}
+
+/**************************************************************************
+  Converts the given geff_vector into a ceff_vector (struct eff_global is
+  a derived class of struct eff_city, and by the same token geff_vector
+  is derived from ceff_vector). The returned vector functions exactly as
+  the orginal geff_vector, but returns eff_city structures.
+**************************************************************************/
+struct ceff_vector *get_geff_parent(struct geff_vector *geff)
+{
+  return (struct ceff_vector *)geff;
+}
+
+/**************************************************************************
+  Fills in the efflist pointer array with the eff_global lists that could
+  be changed by the given improvement (in the given city) being built
+  or destroyed.
+**************************************************************************/
+void get_effect_vectors(struct ceff_vector *ceffs[],
+    			struct geff_vector *geffs[],
+			Impr_Type_id impr, struct city *pcity)
+{
+  struct impr_effect *ie;
+  int j, i, cont;
+  bool effects[EFR_LAST];
+  struct player *plr;
+
+  assert(pcity && impr >= 0 && impr < game.num_impr_types);
+
+  for (i = 0; i < EFR_LAST; i++) {
+    effects[i] = FALSE;
+  }
+
+  if ((ie = improvement_types[impr].effect)) {
+    for (; ie->type < EFT_LAST; ie++) {
+      effects[ie->range] = TRUE;
+    }
+  }
+
+  plr = city_owner(pcity);
+  cont = map_get_continent(pcity->x, pcity->y);
+
+  i = 0;
+  for (j = 0; j < EFR_LAST; j++) {
+    if (effects[j]) {
+      switch(j) {
+      case EFR_ISLAND:
+	geffs[i++] = get_eff_island(cont, plr);
+	break;
+      case EFR_PLAYER:
+	geffs[i++] = get_eff_player(plr);
+	break;
+      case EFR_WORLD:
+	geffs[i++] = get_eff_world();
+	break;
+      default:
+	break;
+      }
+    }
+  }
+  geffs[i++] = NULL;
+
+  ceffs[0] = get_eff_city(pcity);
+  ceffs[1] = NULL;
+}
+
+/**************************************************************************
+  Updates the relevant global effect structures, to bring them into
+  line with the current activity status of their parent city structure,
+  which should be owned by the passed pcity and pplayer (either can be
+  NULL for destroyed effects).
+**************************************************************************/
+void update_global_effect(struct city *pcity, struct player *pplayer,
+			  struct eff_city *effect)
+{
+  struct geff_vector *effs[EFR_LAST];
+  int i, j;
+
+  for (i = 0; i < EFR_LAST; i++) {
+    effs[i] = NULL;
+  }
+
+  if (pplayer) {
+    effs[EFR_PLAYER] = get_eff_player(pplayer);
+    if (pcity) {
+      int cont = map_get_continent(pcity->x, pcity->y);
+      effs[EFR_ISLAND] = get_eff_island(cont, pplayer);
+    }
+  }
+  effs[EFR_WORLD] = get_eff_world();
+
+  for (j = 0; j < EFR_LAST; j++) {
+    if (effs[j]) {
+      for (i = 0; i < geff_vector_size(effs[j]); i++) {
+        struct eff_global *eff = geff_vector_get(effs[j], i);
+
+	if ((!pcity || eff->cityid == pcity->id)
+	    && (!pplayer || eff->plr == pplayer)
+	    && eff->eff.impr == effect->impr) {
+	  eff->eff.active = effect->active;
+	  break;
+        }
+      }
+    }
+  }
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct eff_city *append_ceff(struct ceff_vector *x)
+{
+  int i, n;
+  struct eff_city *eff;
+
+  /* Try for an unused vector instance if possible. */
+  n = ceff_vector_size(x);
+  for (i = 0; i < n; i++) {
+    eff = ceff_vector_get(x, i);
+    if (eff->impr == B_LAST) {
+      return eff;
+    }
+  }
+
+  /* That didn't work, so add a new instance to the vector. */
+  ceff_vector_reserve(x, n + 1);
+  return ceff_vector_get(x, n);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct eff_global *append_geff(struct geff_vector *x)
+{
+  int i, n;
+  struct eff_global *eff;
+
+  /* Try for an unused vector instance if possible. */
+  n = geff_vector_size(x);
+  for (i = 0; i < n; i++) {
+    eff = geff_vector_get(x, i);
+    if (eff->eff.impr == B_LAST) {
+      return eff;
+    }
+  }
+
+  /* That didn't work, so add a new instance to the vector. */
+  geff_vector_reserve(x, n + 1);
+  return geff_vector_get(x, n);
+}
+
+/**************************************************************************
+  Fills in the efflist pointer array with the relevant ceff_vectors for
+  the given improvement, in the given city, on the given island, and the
+  given player. B_LAST, NULL, -1 and NULL respectively cause those ranges
+  to be skipped (i.e. returned as NULL).
+**************************************************************************/
+void get_all_effect_vectors(struct ceff_vector *effs[EFR_LAST],
+			    Impr_Type_id impr, struct city *pcity,
+                            int cont, struct player *plr)
+{
+  int i;
+
+  for (i = 0; i < EFR_LAST; i++) {
+    effs[i] = NULL;
+  }
+
+  if (pcity) {
+    effs[EFR_CITY] = get_eff_city(pcity);
+    if (impr != B_LAST) {
+      effs[EFR_LOCAL] = effs[EFR_CITY];
+    }
+  }
+
+  if (plr) {
+    effs[EFR_PLAYER] = get_geff_parent(get_eff_player(plr));
+    if (cont != -1) {
+      effs[EFR_ISLAND] = get_geff_parent(get_eff_island(cont, plr));
+    }
+  }
+
+  effs[EFR_WORLD] = get_geff_parent(get_eff_world());
+}
+
+/**************************************************************************
+  Returns TRUE if the given building (if not B_LAST), city or player
+  are being affected by the given effect; the player should be the owner of
+  the city (and will be filled in if city is specified and player is NULL)
+**************************************************************************/
+bool is_under_effect(Impr_Type_id impr, struct city *pcity,
+		     struct player *pplayer, enum effect_type cond_eff)
+{
+ if (!pplayer && pcity) {
+   pplayer = city_owner(pcity);
+ }
+
+ impr_effects_iterate(iter, impr, pcity, pplayer) {
+   if (iter.imeff->type == cond_eff) {
+     return TRUE;
+   }
+ } impr_effects_iterate_end;
+
+  return FALSE;
+}
+
+/**************************************************************************
+  Returns TRUE if the given effect (in the given city, owned by the given
+  player) is activated by all of the necessary prerequisites;
+  *cond_eff is set to TRUE if the effect could not be activated because it
+  depends on another effect;
+  pcity and/or pplayer can be NULL for destroyed effects.
+  Note: the cond_bldg field, and the various aff_xxx fields, are not
+        checked, as one effect may affect several cities, terrains, etc.
+        Use the is_city_affected and is_unit_terrain_affected functions to
+        determine if a so-called "active" effect really is.
+**************************************************************************/
+bool is_effect_activated(Impr_Type_id impr, struct city *pcity,
+			 struct player *pplayer, struct impr_effect *imeff,
+                         bool *cond_eff)
+{
+  if (imeff->cond_gov != game.government_count && pplayer
+      && pplayer->government != imeff->cond_gov) {
+    freelog(LOG_DEBUG, "Effect requires a government");
+    return FALSE;
+  }
+  if (pplayer && get_invention(pplayer, imeff->cond_adv) != TECH_KNOWN) {
+    freelog(LOG_DEBUG, "Effect requires a future tech");
+    return FALSE;
+  }
+  if (imeff->cond_eff != EFT_LAST
+      && !is_under_effect(impr, pcity, pplayer, imeff->cond_eff)) {
+    freelog(LOG_DEBUG, "Effect requires another effect");
+    if (cond_eff) {
+      *cond_eff = TRUE;
+    }
+    return FALSE;
+  }
+  return TRUE;
+}
+
+/**************************************************************************
+  Sets an effect iterator to the start of the effect lists - common
+  function used by other effect iterator initialisation functions
+**************************************************************************/
+static void eff_iterator_start(struct eff_iter *iter)
+{
+  iter->imeff = NULL;
+  iter->range = 0;
+  iter->index = 0;
+  iter->bitmask = 1;
+}
+
+/**************************************************************************
+  Initialises an effect iterator structure (a pointer to which should be
+  passed in as the first argument). The iterator will return all improvement
+  effects which affect the designated improvement in the given city owned
+  by the given player (if impr is B_LAST, and/or pcity/pplayer is NULL,
+  the respective ranges are skipped)
+**************************************************************************/
+void eff_iterator_impr_init(struct eff_iter *iter, Impr_Type_id impr,
+                            struct city *pcity, struct player *pplayer)
+{
+  int cont = -1;
+
+  assert(iter != NULL);
+
+  if (pcity)
+    cont = map_get_continent(pcity->x, pcity->y);
+
+  get_all_effect_vectors(iter->effs, impr, pcity, cont, pplayer);
+
+  iter->utype = U_LAST;
+  iter->impr = impr;
+  iter->pcity = pcity;
+  iter->pplayer = pplayer;
+  iter->aff_unit.move_type = LAST_MOVING;
+
+  if (pcity) {
+    iter->aff_terr = map_get_terrain(pcity->x, pcity->y);
+    iter->aff_spec = map_get_special(pcity->x, pcity->y);
+  } else {
+    iter->aff_terr = T_UNKNOWN;
+    iter->aff_spec = S_ALL;
+  }
+
+  eff_iterator_start(iter);
+}
+
+/**************************************************************************
+  Similar to the above function, this initialises an effect iterator for
+  considering effects that influence a unit that is owned by the given
+  player and is at the given map coordinates (if pplayer and/or mp are NULL,
+  the unit is considered unowned and/or unpositioned)
+**************************************************************************/
+void eff_iterator_unit_init(struct eff_iter *iter, Unit_Type_id utype,
+    			    Unit_Type_id aff_utype,
+                            struct player *pplayer, struct map_position *mp)
+{
+  int cont = -1;
+  struct city *pcity = NULL;
+
+  assert(iter != NULL);
+
+  if (mp) {
+    pcity = map_get_city(mp->x, mp->y);
+    cont = map_get_continent(mp->x, mp->y);
+  }
+
+  get_all_effect_vectors(iter->effs, B_LAST, pcity, cont, pplayer);
+
+  iter->utype = utype;
+  iter->impr = B_LAST;
+  iter->pcity = pcity;
+  iter->pplayer = pplayer;
+  get_unittype_classes(aff_utype, &iter->aff_unit);
+
+  if (mp) {
+    iter->aff_terr = map_get_terrain(mp->x, mp->y);
+    iter->aff_spec = map_get_special(mp->x, mp->y);
+  } else {
+    iter->aff_terr = T_UNKNOWN;
+    iter->aff_spec = S_ALL;
+  }
+
+  eff_iterator_start(iter);
+}
+
+struct impr_effect *get_base_effect(Impr_Type_id impr, struct player *pplayer)
+{
+  switch(impr) {
+  case B_NATION:
+    return get_nation_by_plr(pplayer)->effect;
+  case B_GOV:
+    return get_gov_pplayer(pplayer)->effect;
+  default:
+    break;
+  }
+  return improvement_types[impr].effect;
+}
+
+const char *get_effect_cause_name(Impr_Type_id impr, struct player *pplayer)
+{
+  switch(impr) {
+  case B_NATION:
+    return pplayer ? get_nation_name(pplayer->nation) : "unknown nation";
+  case B_GOV:
+    return pplayer ? get_government_name(pplayer->government)
+                   : "unknown government";
+  default:
+    break;
+  }
+  return get_improvement_name(impr);
+}
+
+/**************************************************************************
+  Given an initialised effect iterator, returns the next active effect.
+  iter->imeff also points to this effect (the data is in the ruleset, so
+  should NOT be freed when you're done with it). NULL is returned when no
+  more effects can be found. Does _not_ consider the various aff_xxx fields.
+
+  N.B. Don't go adding/removing effects while an iteration is in progress!
+**************************************************************************/
+static struct impr_effect *eff_iterator_next_internal(struct eff_iter *iter)
+{
+  struct ceff_vector *ceff;
+  struct eff_city *effect;
+  int efflen;
+
+  assert(iter != NULL);
+
+  /* Return immediately if the iterator is exhausted */
+  if (!iter->imeff && iter->range != 0)
+    return NULL;
+
+  /* Loop over all valid ranges */
+  for (; iter->range < EFR_LAST; iter->range++) {
+    ceff = iter->effs[iter->range];
+    /* We don't currently pre-activate unittype effects, so must check
+     * each effect for activation */
+    if (iter->range == EFR_LOCAL && iter->utype != U_LAST) {
+      if (iter->imeff) {
+        iter->imeff++;
+      } else {
+        iter->imeff = get_unit_type(iter->utype)->effect;
+      }
+      for (; iter->imeff && iter->imeff->type != EFT_LAST; iter->imeff++) {
+        if (is_effect_activated(iter->impr, iter->pcity, iter->pplayer,
+				iter->imeff, NULL)
+	    && is_city_affected(iter->imeff, iter->pcity)) {
+	  return iter->imeff;
+	}
+      }
+      iter->imeff = NULL;
+    } else if (ceff) {
+      efflen = ceff_vector_size(ceff);
+      for (; iter->index < efflen; iter->index++) {
+        effect = ceff_vector_get(ceff, iter->index);
+        if (effect->impr != B_LAST) {
+          if (iter->imeff) {
+            /* Make sure we don't return the same effect again */
+            iter->imeff++; iter->bitmask <<= 1;
+          } else {
+            iter->imeff = get_base_effect(effect->impr, iter->pplayer);
+            iter->bitmask = 1;
+          }
+          for (; iter->imeff && iter->imeff->type != EFT_LAST;
+               iter->imeff++, iter->bitmask <<= 1) {
+	    if (iter->imeff->range == iter->range) {
+	      freelog(LOG_DEBUG, "Effect iteration: effect %s at range %s",
+		      effect_type_name(iter->imeff->type),
+		      effect_range_name(iter->range));
+	    }
+
+            if (effect->active & iter->bitmask
+                && iter->imeff->range == iter->range
+                && (iter->imeff->range != EFR_LOCAL
+                    || effect->impr == iter->impr)
+                && is_city_affected(iter->imeff, iter->pcity)
+		&& is_effect_outside(iter->imeff, iter->pcity)) {
+              return iter->imeff;
+            }
+          }
+          /* Force reinitialisation of imeff next time round */
+          iter->imeff = NULL;
+        }
+      }
+    }
+    /* Make sure we restart at zero for the next range out */
+    iter->index = 0;
+  }
+  /* We didn't match any more effects, so signal that we're done */
+  iter->imeff = NULL;
+  return NULL;
+}
+
+/**************************************************************************
+  Returns the next active effect that satisfies the aff_xxx fields set for
+  the city/unit etc. when the iterator was initialised.
+**************************************************************************/
+struct impr_effect *eff_iterator_next(struct eff_iter *iter)
+{
+  struct impr_effect *imeff;
+
+  do {
+    imeff = eff_iterator_next_internal(iter);
+    if (imeff && is_unit_terrain_affected(imeff, &iter->aff_unit,
+                                          iter->aff_terr, iter->aff_spec)) {
+      return imeff;
+    }
+  } while(imeff);
+  return NULL;
+}
+
+/**************************************************************************
+  Returns the next active effect that satisfies the various aff_xxx fields
+  passed (use NULL, T_UNKNOWN and/or S_ALL respectively if you want
+  any value - except "None" - to match)
+**************************************************************************/
+struct impr_effect *eff_iterator_next_full(struct eff_iter *iter,
+                                           struct unit_classes *aff_unit,
+                                           enum tile_terrain_type aff_terr,
+                                           enum tile_special_type aff_spec)
+{
+  struct impr_effect *imeff;
+
+  do {
+    imeff = eff_iterator_next_internal(iter);
+    if (imeff && is_unit_terrain_affected(imeff, aff_unit, aff_terr,
+                                          aff_spec)) {
+      return imeff;
+    }
+  } while(imeff);
+  return NULL;
+}
+
+/**************************************************************************
+  Returns the ID of the improvement that is conferring the last effect
+  returned from the iterator, or B_LAST if no building is doing so
+**************************************************************************/
+Impr_Type_id eff_iterator_get_improvement(struct eff_iter *iter)
+{
+  struct ceff_vector *ceff;
+  struct eff_city *effect;
+
+  assert(iter != NULL);
+
+  if (!iter->imeff)
+    return B_LAST;
+
+  ceff = iter->effs[iter->range];
+  effect = ceff_vector_get(ceff, iter->index);
+
+  return effect->impr;
+}
+
+/**************************************************************************
+  Returns TRUE if the given effect should affect the given city (i.e. it
+  has the building required for the effect to be active)
+**************************************************************************/
+bool is_city_affected(struct impr_effect *imeff, struct city *pcity)
+{
+  return (imeff->cond_bldg == B_LAST
+          || (pcity && city_got_building(pcity, imeff->cond_bldg)));
+}
+
+/**************************************************************************
+  Returns TRUE if the given effect is in a city, or if it's in the field
+  and its "outside" flag is set, or if "outside" is ignored for this effect
+**************************************************************************/
+bool is_effect_outside(struct impr_effect *imeff, struct city *pcity)
+{
+  if (!pcity && !imeff->outside) {
+    switch(imeff->type) {
+    case EFT_UNIT_DEFEND:
+    case EFT_UNIT_ATTACK:
+    case EFT_UNIT_DEFEND_FIREPOWER:
+    case EFT_UNIT_ATTACK_FIREPOWER:
+    case EFT_UNIT_RECOVER:
+    case EFT_UNIT_VET_COMBAT:
+    case EFT_UPGRADE_ONE_STEP:
+    case EFT_UPGRADE_ONE_LEAP:
+    case EFT_UPGRADE_ALL_STEP:
+    case EFT_UPGRADE_ALL_LEAP:
+      return FALSE;
+    default:
+      break;
+    }
+  }
+  return TRUE;
+}
+
+/**************************************************************************
+  Returns TRUE if the given effect should affect the given
+  unit/terrain/special, by checking the relevant aff_xxx fields
+  (Pass in NULL, T_UNKNOWN, and S_ALL respectively if you don't care
+  about that field; these values will match everything except "None".)
+**************************************************************************/
+int is_unit_terrain_affected(struct impr_effect *imeff,
+    			     struct unit_classes *aff_unit,
+                             enum tile_terrain_type aff_terr,
+                             enum tile_special_type aff_spec)
+{
+  return is_unit_class_in_set(imeff->aff_unit, aff_unit)
+         && (((aff_terr == T_UNKNOWN && imeff->aff_terr != T_LAST)
+             || imeff->aff_terr == T_UNKNOWN || imeff->aff_terr == aff_terr)
+             || imeff->aff_spec & aff_spec);
+}
+
+/**************************************************************************
+  Returns the index of the improvement which provides the given effect
+  (constrained to the given unit class and player, if not 0 and
+  NULL respectively) or B_LAST if no suitable improvement could be found.
+**************************************************************************/
+Impr_Type_id get_improvement_for_effect(struct player *pplayer,
+                                        enum effect_type id,
+                                        struct unit_classes *aff_unit)
+{
+  int impr;
+  struct impr_effect *eff;
+
+  for (impr = 0; impr < game.num_impr_types; impr++) {
+    for (eff = improvement_types[impr].effect;
+         eff && eff->type != EFT_LAST; eff++) {
+      if (eff->type == id
+          && (!pplayer || can_player_build_improvement(pplayer, impr))
+          && is_unit_terrain_affected(eff, aff_unit, T_UNKNOWN, S_ALL)) {
+        return impr;
+      }
+    }
+  }
+  return B_LAST;
+}
+
+/**************************************************************************
+  Adds the effects of a previously-destroyed improvement to the given
+  players's destroyed effects vector (if player=NULL, then adds them to
+  the global game destroyed effects vector instead).
+**************************************************************************/
+void add_destroyed_improvement(struct player *p, Impr_Type_id id)
+{
+  struct ceff_vector *desteff;
+  struct eff_city *ceff;
+
+  game.destroyed_owner[id] = p;
+  freelog(LOG_DEBUG, "Adding destroyed improvement %s to %s",
+          improvement_types[id].name, p ? p->name : "global list");
+
+  desteff = (p ? &p->destroyed_effects : &game.destroyed_effects);
+  ceff = append_ceff(desteff);
+  ceff->impr = id;
+  ceff->active = 0;
+  add_global_effects(id, p);
+}
+
+static void get_global_effects(Impr_Type_id impr, struct player *pplayer,
+    			       struct geff_vector *globeff[])
+{
+  struct impr_effect *imeff;
+
+  globeff[0] = globeff[1] = NULL;
+  for (imeff = get_base_effect(impr, pplayer);
+       imeff && imeff->type != EFT_LAST; ++imeff) {
+    if (imeff->range == EFR_WORLD) {
+      globeff[1] = get_eff_world();
+    } else if (imeff->range == EFR_PLAYER) {
+      globeff[0] = get_eff_player(pplayer);
+    }
+  }
+}
+
+void remove_global_effects(Impr_Type_id impr, struct player *pplayer)
+{
+  struct geff_vector *globeff[2];
+  int i, effind;
+
+  get_global_effects(impr, pplayer, globeff);
+  for (i = 0; i < 2; ++i) {
+    if (globeff[i]) {
+      for (effind = 0; effind < geff_vector_size(globeff[i]); ++effind) {
+        struct eff_global *eff = geff_vector_get(globeff[i], effind);
+
+	if (eff->cityid == -1 && eff->eff.impr == impr && eff->plr == pplayer) {
+	  eff->eff.impr = B_LAST;
+	}
+      }
+    }
+  }
+}
+
+void add_global_effects(Impr_Type_id impr, struct player *pplayer)
+{
+  struct geff_vector *globeff[2];
+  int i;
+
+  get_global_effects(impr, pplayer, globeff);
+  for (i = 0; i < 2; ++i) {
+    if (globeff[i]) {
+      struct eff_global *geff;
+
+      geff = append_geff(globeff[i]);
+      geff->eff.impr = impr;
+      geff->eff.active = 0;
+      geff->cityid = -1;
+      geff->plr = pplayer;
+    }
+  }
+}
